define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for Mapa generated by Appery.io
         * @module Mapa
         */
        APP.controller('Mapa', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.operatorList = Apperyio.EntityAPI('OperatorList');
            /**
             * User controller functions
             */
            /**
             * @function init
             */
            $scope.init = function() {
                //On load screen logic
                $scope.empresa = JSON.parse(localStorage.getItem("companyData"));
                $scope.mOperators = localStorage.getItem("arrayOperators") ? JSON.parse(localStorage.getItem("arrayOperators")) : [];
                $scope.refresco = 60 * 10;
                $scope.map = {
                    control: {},
                    center: $scope.centerMapApp,
                    zoom: 12
                }
                cargarMapa();
            };
            /**
             * @function goToMapaUsuario
             * @param idUsuario
             * @param nombre
             * @param username
             */
            $scope.goToMapaUsuario = function(idUsuario, nombre, username) {
                //Apperyio.navigateTo("MapaUsuario", {"idUsuario":idUsuario});
                Apperyio.get('userManager').operatorId = idUsuario;
                Apperyio.get('userManager').operatorName = nombre;
                Apperyio.get('userManager').operatorUsername = username;
                Apperyio.get('Modals').loadModal("ShowMapaRutasTecnico").then(
                    function(modal) {
                        modal.scope.current_item = {
                            // Set input object for send to modal window
                            // Value: .itemFromModal
                        };
                        modal.scope.modalInstance = modal.open({
                            // Optional settings:
                            size: 'lg',
                            /* 'lg' | 'sm' */
                            backdrop: true,
                            /* true | false | 'static' */
                            keyboard: true,
                            /* true | false */
                            backdropClass: '',
                            /* backdropClass name */
                            windowClass: '',
                            /* additional CSS class(es) to be added to a modal window template */
                            windowTemplateUrl: '' /* a path to a template overriding modal's window template */
                        });
                        modal.scope.modalInstance.result.then(
                            function(current_item) {
                                // Custom implementation with modal response with current_item
                            },
                            function(error) {
                                console.log(error);
                            }
                        );
                    });
            };
            /**
             * @function cargarMapa
             */
            function cargarMapa() {
                //$scope.showLoading();
                console.log("Recargando Mapa...");
                $scope.showLoading("Recargando Mapa");
                var requestData = {};
                requestData = (function mapping7415($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [{
                                "idCliente": $scope.empresa.idCliente
                            },
                            {
                                "profile": "OP"
                            }
                        ]
                    };
                    return requestData;
                    /*CLICK TO EDIT MAPPING*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_OPERATORS_query_service")(requestData).then(
                    function(success) { // success callback
                        (function mapping6454(success, $scope) {
                            var operatorList_scope = $scope.operatorList;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(operatorList_scope, '[' + i + '].idCliente', success.data[i].idCliente);
                                _.set(operatorList_scope, '[' + i + '].idOperador', success.data[i].idOperador);
                                _.set(operatorList_scope, '[' + i + '].nombre', $scope.allNamesAsoc[success.data[i].idOperador]);
                                _.set(operatorList_scope, '[' + i + '].username', $scope.allUsernamesAsoc[success.data[i].idOperador]);
                                _.set(operatorList_scope, '[' + i + '].estadoOperador', success.data[i].estadoOperador);
                                _.set(operatorList_scope, '[' + i + '].profile', success.data[i].profile);
                                _.set(operatorList_scope, '[' + i + '].marker', success.data[i].lastReportGps ? JSON.parse(success.data[i].lastReportGps) : {});
                            }
                            $scope.operatorList = operatorList_scope;
                            /*CLICK TO EDIT MAPPING*/
                        })(success, $scope);
                        $scope.stopLoading();
                        //setTimeout(function(){cargarMapa()}, $scope.refresco*1000);
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        $scope.mAlert("Hubo errores al cargar los datos de los operadores: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function test
             */
            $scope.test = function() {
                alert(1);
            };
            /**
             * @function goToMapaUsuarioOrdenes
             * @param idUsuario
             * @param nombre
             * @param username
             */
            $scope.goToMapaUsuarioOrdenes = function(idUsuario, nombre, username) {
                //Apperyio.navigateTo("MapaUsuario", {"idUsuario":idUsuario});
                Apperyio.get('userManager').operatorId = idUsuario;
                Apperyio.get('userManager').operatorName = nombre;
                Apperyio.get('userManager').operatorUsername = username;
                Apperyio.get('userManager').stateList = $scope.stateList;
                Apperyio.get('Modals').loadModal("ShowMapaRutasTecnicoOrdenes").then(
                    function(modal) {
                        modal.scope.current_item = {
                            // Set input object for send to modal window
                            // Value: .itemFromModal
                        };
                        modal.scope.modalInstance = modal.open({
                            // Optional settings:
                            size: 'lg',
                            /* 'lg' | 'sm' */
                            backdrop: true,
                            /* true | false | 'static' */
                            keyboard: true,
                            /* true | false */
                            backdropClass: '',
                            /* backdropClass name */
                            windowClass: '',
                            /* additional CSS class(es) to be added to a modal window template */
                            windowTemplateUrl: '' /* a path to a template overriding modal's window template */
                        });
                        modal.scope.modalInstance.result.then(
                            function(current_item) {
                                // Custom implementation with modal response with current_item
                            },
                            function(error) {
                                console.log(error);
                            }
                        );
                    });
            };
        }
    });